package choco;

import org.chocosolver.solver.Model;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.*;

import static org.chocosolver.solver.search.strategy.Search.minDomLBSearch;

public class n_queens {
	public static void main(String[] args) {
	int n = 1000;
	Model model = new Model(n + "-queens problem");
	Solver s = model.getSolver();
 
	IntVar[] queens = model.intVarArray("Q", n, 1, n, false);
	IntVar[] diag1 = new IntVar[n];
	IntVar[] diag2 = new IntVar[n];
	for(int i = 0 ; i < n; i++){
		diag1[i] = queens[i].sub(i).intVar();
		diag2[i] = queens[i].add(i).intVar();}
	String st = "BC"; //"AC", "AC-REGIN", "AC-ZHANG", "BC", "DEFAULT", "FC", "NEQS"
	model.post(
		model.allDifferent(queens, st),
		model.allDifferent(diag1,  st),
		model.allDifferent(diag2,  st));
	
	// Use fail-first Heuristics 
		s.setSearch(minDomLBSearch(queens));

		
	// Solve and show statistics
	s.solve();
	//for (int i = 0; i < n; i++) System.out.print(" "+ queens[i].getValue());
	System.out.println();
	//s.printStatistics();
	System.out.println("       number of failures = " + String.valueOf(s.getFailCount()));
	System.out.println("     number of backtracks = " + String.valueOf(s.getBackTrackCount()));
	System.out.println("    elapsed cpu time (ms) = " + String.valueOf(s.getTimeCount()*1000));
	}
}